Subject: Comments from John Thornley

Date: Fri, 8 Jul 1994 09:00:35 +0500

Comments from John Thornley

In an earlier message to me John made the following points which I think are of interest to the whole group.

Basil

The Electronic Journal of Terrestrial Ecosystems Software

Publishing models is a pain at present and is thoroughly unsatisfactory.
Therefore let's try something different.  Maybe it'll work and maybe it won't.
So count me in.

I'll give you some of my views on publishing models.

1. Other people's programs are usually difficult/impossible to understand.
The most important thing about the write-up of a model is 
(not that it should be "validated" or some such stuff, but)
that it should be understandable - as transparent as possible.
Then people can decide what bits, if any, to use themselves.

2. If only everyone had taken on board the stuff de Wit was saying
25 years ago.  Define your state variables (with initial values),
define the difference/differential equations, and last give the
rate processes equations with parameter values.  Some referencing of why
is helpful but this need not be exhaustive.

3.  I still find a mathematical statement the clearest to understand.
(If only so many biologists/ag engnrs hadn't learnt computer programming
before learning maths.)  I am always delighted when people take one
of my models, and code it up directly from the maths, and it works.
And this has happened more than once.  Computer languages will go on
changing for a while yet - therefore a computer coding is only of
transient value.  A mathematical description has a much longer life.

4.  You ask for text etc in ASCII.  I guess me and many colleagues 
write our ms's in WordPerfect or Word which have pretty good eqn writers. 
We could print/postcript our files and get an ASCII file.  But these files
probably aren't of much use electronic journal-wise.
In the US, LATEX or something like it seems to be more widespread
than over here.  I guess some people who use say WordPerfect for
letters, reports, ms's etc would not want to switch and start climbing
up some new learning curve.  I don't know what the NAPLPS standard is.

5.  Software.  Fortran is widely used but it is a lousy language for
ecosystem software.  An ecosytem/crop model is the ultimate
parallel process, and fortran is not good for parallel processes.  
Some people use a variety of special simulation languages, mostly because
they know their way around them and it makes model coding much easier
than in fortran.     I use ACSL at presemt - more or less a successor
to CSMP.  But ACSL software costs $$$ and most people can't run my
programs.  Nothing is perfect.  I simply can't see busy people
spending much time running other peoples models with all the
problems that would arise.  Big models can be desperate things to
work with - even when you've built them yourself.
 
6.  Refereeing.  With recent changes in the UK research scene there
are very few possible referees of ecosystem models.  I already am
sent more stuff than I want just because competent modellers are so
thin on the ground.  I suppose things are a bit more robust where
you are with more possibilities.  

I guess much of this seems pretty negative, but there is a logjam in
publishing modelling work, and someone has to try and break it.

John